#if !defined(_IMPORT_H_)
#define _IMPORT_H_

#if !defined(MAX)
#define MAX(a,b) ( (a) > (b) ? (a) : (b) )
#endif
#if !defined(MIN)
#define MIN(a,b) ( (a) < (b) ? (a) : (b) )
#endif

				/* memory alloc */
/*
#define MALLOC mymalloc
#define FREE   dummyfree
extern void * MALLOC ( int nb );
extern void   FREE ( void * p );
*/
#define MALLOC malloc
#define FREE   free

				/* Fortran intrinsics? */
extern int
	iceil_         (const int *, const int *);

				/* LAPACK */
extern void
	dgeev_	       (const char * const lvjob,
			const char * const rvjob,
			const int  * const n,
			double * const a,
			const int * const lda,
			double * const wr, double const * wi,
			double * const vl, const int * const ldvl,
			double * const vr, const int * const ldvr,
			double * const work, int * const lwork,
			int * const info);

                                /* BLACS prototypes */
extern int
	blacs_pnum_    (const int * const ctxt,
			int * const prow, int * const pcol);
extern double
	dcputime00_    (void),
	dlamch_	       (const char * const what);

extern void
	blacs_pinfo_   (int *iam, int *procs),
	blacs_get_     (int *ctxt, int *what, int *val),
	blacs_gridinit_(int *ctxt, char *order, int *nprow, int *npcol),
	blacs_gridmap_ (int *ctxt, int *usermap, int *ldumap,
			int *nprow, int *npcol),
	blacs_gridinfo_(const int * const ctxt,
			int * const nprow, int * const npcol,
			int * const myprow, int * const mypcol),
	blacs_pcoord_  (int *ctxt, int *pnum, int *prow, int *pcol),
	blacs_barrier_ (int *ctxt, char *scope),
	blacs_abort_   (int *ctxt, int *errnum),
	blacs_exit_    (int *ifcontinue),
	dgsum2d_       (const int * const ctxt,
			const char * const scope,
			const char * const topology,
			const int * const m,
			const int * const n,
			double * const a,
			const int * const lda,
			const int * const rdest,
			const int * const cdest);


                                /* ScaLAPACK prototypes */
extern double
	pdlamch_       (const int * const ctxt, const char * const machine),
	pdlange_       (const char * const normtype,
			const int *m, const int *n, const double *a,
			const int *ia, const int *ja,
			const int *desc_a,
			double *work),
	pdlatra_       (const int * const n,
			const double * const a,
			const int * const ia,
			const int * const ja,
			const int * const desc_a);

extern int
	numroc_        (const int *mn,   const int *mnb,
			const int *myrc, const int *startrc,
			const int *nprc);

extern void
	pdlaset_       (double * const a,
			const int *i, const int *j, const double *v),
	pdlaprnt_      (int *m, int *n, double *a, int *i, int *j, int *adesc,
			int *sprow, int *spcol, char *id, int *iounit,
			double *workbuf),
	pdlascl_       (const char * const region,
			const double * const denominator,
			const double * const numerator,
			const int * const m, const int * const n,
			double * const a,
			const int * const ia, const int * const ja,
			const int * const desc_a,
			int * const info),
	pdgemr2d_      (const int * const m, const int * const n,
			const double * const a,
			const int * const ia, const int * const ja,
			const int * const desc_a,
			double * const b,
			const int * const ib, const int * const jb,
			const int * const desc_b),
	pdmatgen_      (const int * const ictxt,
			const char * const aform,
			const char * const diag,
			const int * const m,
			const int * const n,
			const int * const mb,
			const int * const nb,
			double * const a,
			const int * const lda,
			const int * const iarow,
			const int * const iacol,
			const int * const iseed,
			const int * const iroff,
			const int * const irnum,
			const int * const icoff,
			const int * const icnum,
			const int * const myrow,
			const int * const mycol,
			const int * const nprow,
			const int * const npcol);
#endif _IMPORT_H_
