
      SUBROUTINE TOMATLAB1( M, A, IA, JA, DESCA, WORK )
      INTEGER            M, IA, JA
      DOUBLE PRECISION   A( * ), WORK( * )
      INTEGER            DESCA( * )
*
*     Dump everything - in matlab format
*
*     -- Parameters --
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DT_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DT_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      EXTERNAL           DMATPT
*     -- Local Scalars --
      INTEGER            MYROW, MYCOL, NPCOL, NPROW
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, PDMATPT
*
*     == Executable Statements ==
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
     
      IF ( MYROW .EQ. 0 .AND. MYCOL .EQ. 0 ) THEN
         OPEN( 4, FILE='sdebug.m', STATUS='UNKNOWN')
         WRITE (4, '(A, I6, A)') 'm = ', M, ';'
         WRITE (4, '(A)') 'a = ['
      END IF
      CALL PDMATPT(M, A, IA, DESCA, WORK, .TRUE.)
      IF ( MYROW .EQ. 0 .AND. MYCOL .EQ. 0 ) THEN
         WRITE (4, '(A)') '];'
         WRITE (4, '(A)') ' '
      END IF
      RETURN
      END

      SUBROUTINE TOMATLAB2( WANTT, WANTZ, M, T, IT, JT, DESCT,
     $                      Z, IZ, JZ, DESCZ, WR, WI, ERREST, WORK )
      LOGICAL            WANTT, WANTZ
      INTEGER            M, IT, JT, IZ, JZ
      INTEGER            DESCT( * ), DESCZ( * )
      DOUBLE PRECISION   T( * ), Z( * ), WR( * ), WI( * ),
     $                   ERREST, WORK( * )
*
*     Dump everything - in matlab format
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DT_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DT_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      INTEGER            I, MYROW, MYCOL, NPCOL, NPROW
      LOGICAL		 IAMWRITING
      EXTERNAL           PDMATPT, BLACS_GRIDINFO

      CALL BLACS_GRIDINFO( DESCT( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      IAMWRITING = ( MYROW .EQ. 0 .AND. MYCOL .EQ. 0 )

      IF ( IAMWRITING ) THEN
         WRITE (4, '(A)') 'svects=0;evects=0;uppert=0;'
         WRITE (4, '(A)') 'full_update=0;'
         WRITE (4, '(A)') 'evals=1;'
         WRITE (4, '(A, D30.17, A)') 'errest = ', ERREST, ';'
         WRITE (4, '(A)') 'l = ['
         DO 680 I = 1, M
            WRITE (4, '(2D30.17)') WR(I), WI(I)
680      CONTINUE
         WRITE (4, '(A)') '];'
      END IF

      IF ( WANTZ ) THEN
         IF ( IAMWRITING ) THEN
            WRITE (4, '(A)') 'svects=1;'
            WRITE (4, '(A)') 'q = ['
         END IF
         CALL PDMATPT(M, Z, IZ, DESCZ, WORK, .TRUE.)
         IF ( IAMWRITING ) THEN
            WRITE (4, '(A)') '];'
         END IF
      END IF

      IF ( WANTT ) THEN
         IF ( IAMWRITING ) THEN
            WRITE (4, '(A)') 'uppert=1;'
            WRITE (4, '(A)') 't = ['
         END IF
         CALL PDMATPT(M, T, IT, DESCT, WORK, .TRUE.)
         IF ( IAMWRITING ) THEN
            WRITE (4, '(A)') '];'
         END IF
      END IF

      IF ( IAMWRITING ) THEN
         CLOSE(4)
      END IF

      RETURN
      END

      SUBROUTINE DMATPT( M, N, A, II, JJ, LDA , TOFILE )
*
*       II and JJ are offsets into the array A; M and N are the # of rows
*       and cols to print out.
*
*     -- Scalar Arguments --
      INTEGER            LDA, M, N, II, JJ
      LOGICAL            TOFILE
*
*     -- Array Arguments --
      DOUBLE PRECISION   A( LDA, * )
*
*     -- Local Scalars --
      INTEGER            I, J
*
*     == Executable Statements ==
*
*
        IF ( TOFILE ) THEN
           DO 100 I = II, II+M-1
              DO 50 J = JJ, JJ+N-1
                 WRITE (4, '(1D30.17)') A( I, J )
 50           CONTINUE
100        CONTINUE
        ELSE
           DO 200 I = II, II+M-1
              PRINT '(5D15.6)', ( A( I, J ), J = JJ, JJ+N-1 )
200        CONTINUE
        END IF

      RETURN
      END

      SUBROUTINE PDMATPT( N, A, IA, DESCA, WORK, TOFILE )
*
*       IA and JA are offsets into the array A; M and N are the # of rows
*       and cols to print out.
*
*     -- Scalar Arguments --
      INTEGER            N, IA
      LOGICAL            TOFILE
*
*     -- Array Arguments --
      DOUBLE PRECISION   A( * ), WORK( * )
      INTEGER            DESCA( * )
*
*     -- Parameters --
      INTEGER            BLOCK_CYCLIC_2D, CSRC_, CTXT_, DLEN_, DT_,
     $                   LLD_, MB_, M_, NB_, N_, RSRC_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DT_ = 1,
     $                     CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                     RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     -- Local Scalars --
      INTEGER            MYROW, MYCOL, NPCOL, NPROW
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, PDLACP3, BLACS_BARRIER,
     $                   DMATPT
*
*     == Executable Statements ==
*
*       TOFILE == .TRUE.  => write the matrix to our file.
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )

      CALL PDLACP3( N, IA, A, DESCA, WORK, N, 0, 0, 0 )
      IF ( MYROW .EQ. 0 .AND. MYCOL .EQ. 0 ) THEN
         CALL DMATPT( N, N, WORK, 1, 1, N, TOFILE )
      END IF

      CALL BLACS_BARRIER( DESCA( CTXT_ ), 'All' )

      RETURN
      END
